<template>
    <div
        v-on:drop.prevent="fileDragged"
        v-on:dragover="block"
        v-on:dragleave.prevent="block"
        >
        <el-menu class="topbar"
            mode="horizontal">
            <el-menu-item @click="sidebarToggle" index="1" style="margin-left:0.5em">
                <el-tooltip
                    :content="isSidebarCollapsed ?
                        $t('topbar.hamburger.expande') :
                        $t('topbar.hamburger.collapse')"
                    placement="bottom"
                    effect="dark">
                    <font-awesome-icon
                        icon="bars"
                        :style="rotation"></font-awesome-icon>
                </el-tooltip>
            </el-menu-item>
            <el-menu-item @click="$refs.searchingFor.focus()">
                <span style="margin-right:1em;margin-left:2em">{{$t("topbar.search.label")}}</span>
                <el-input ref="searchingFor" v-model="searchingFor" :placeholder="$t('topbar.search.placeholder')" :style="{width:'12em'}"></el-input>
                <el-popover
                    placement="bottom"
                    :value="isSearching"
                    class="no-padding">
                        <el-cascader-panel style="position:static" v-model="selection" v-bind:options="options" expandTrigger="hover"></el-cascader-panel>
                </el-popover>
            </el-menu-item>
            <el-menu-item>
                <el-button size="small" type="primary"
                    @drop.prevent="fileDragged"
                    @click="$refs.fileUpload.click()">
                    {{$t("topbar.fileUpload")}}
                </el-button>
                <input type="file" style="display:none" ref="fileUpload">
                <!--
                <el-upload :on-change="fileUpload" ref="uploader" :show-file-list="false" class="el-upload--inline" v-model="file" drag action="https://jsonplaceholder.typicode.com/posts/">
                </el-upload>
                -->
            </el-menu-item>
            <el-submenu index="2" class="dock-right">
                <template slot="title">
                    <span>{{$store.getters.isLogged ?
                        $t("topbar.profileMenu.label.logged", {name: $store.state.user.username}) :
                        $t("topbar.profileMenu.label.logging")}}</span>
                    <el-avatar size="medium" :src="avatar" style="margin-left:0.5em"></el-avatar>
                </template>
                <el-menu-item index="2-1" @click="$router.push({name: 'profile'})">{{$t("topbar.profileMenu.profile")}}</el-menu-item>
                <el-menu-item index="2-2">{{$t("topbar.profileMenu.notifications")}}</el-menu-item>
                <el-menu-item @click="logout" index="2-3">{{$t("topbar.profileMenu.logout")}}</el-menu-item>
                <el-menu-item @click="disconnect" index="2-4">{{$t("topbar.profileMenu.disconnect")}}</el-menu-item>
            </el-submenu>
        </el-menu>
    </div>
</template>
<style language="scss" scoped>
    .el-menu--horizontal > .el-menu-item.dock-right,.el-submenu.dock-right {
        float: right;
    }
    .el-upload--inline {
        height:1rem;
        width:5rem;
    }
</style>
<style>
    .no-padding > .el-popover {
        padding:0;
    }
    .el-cascader-panel > .el-cascader-menu {
        height:120%;
    }
    .el-upload--inline .el-upload-dragger {
        width: unset;
        height: unset;
        border: unset;
        background-color: unset;
    }
</style>
<script>
"use strict";

// TODO add default avatar as image
// TODO I don't like how the search results are visually implemented. Find something better.
export default {
    name: "Topbar",
    data() {
        return {
            searchingFor: "",
            options: [],
            selection: null,
            console: console
        };
    },
    computed: {
        isSidebarCollapsed() {
            return this.$store.state.ui.sidebar.isCollapsed;
        },
        rotation() {
            return {
                transform: `rotate(${this.isCollapse? 90 : 0}deg)`
            };
        },
        avatar() {
            return typeof this.$store.state.user.avatar === "undefined" ?
                "https://ramcotubular.com/wp-content/uploads/default-avatar.jpg" :
                this.$store.state.user.avatar;
        },
        isSearching() {
            return this.searchingFor.length > Number.parseInt(process.env.MINIMUM_CHARACTERS_FOR_SEARCH) && this.$refs.searchingFor.focused;
        }
    },
    watch: {
        // When searching, trigger a... well, a search
        searchingFor() {
            if (this.isSearching) {
                this.search(this.searchingFor);
            } else {
                this.$store.commit("searchResultsSet", null);
            }
        },
        selection() {
            // Changing your selection (in the search results panel, NOT in the input box) will trigger a route change
            if (this.selection !== "") {
                this.$router.push("/" + this.selection);
                this.selection = "";
                this.searchingFor = "";
            }
        }
    },
    methods: {
        async logout() {
            // Perform logout and return to home
            await this.$store.dispatch("logout");
            try {
                await this.$router.push({name: "home"});
            } catch (ignore) {/* Already in home */}
        },
        async disconnect() {
            // Perform logout and return to home
            await this.$store.dispatch("disconnect");
            try {
                await this.$router.push({name: "home"});
            } catch (ignore) {/* Already in home */}
        },
        sidebarToggle() {
            this.$store.commit("sidebarToggle");
        },
        async search(searchingFor) {
            // Search in page titles -which are stored on the client
            var routes = this.$router.options.routes.filter((route) => {
                return new RegExp(`${this.searchingFor.toUpperCase()}`).test(route.meta.title.toUpperCase());
            });
            // Dispatch search on the api
            await this.$store.dispatch("generalSearch", searchingFor);
            // Get the results and compute them in a way that makes sense for our menu
            var results = this.$store.state.search.results;
            results.routes = routes;
            this.options = this.resultsCompute(results);
        },
        resultsCompute(results) {
            var menuItems = [];
            Reflect.ownKeys(results).forEach((key) => {
                if (key !== "__ob__" && results[key].length > 0) {
                    const newItem = {
                        label: this.$t(`topbar.search.results.${key}`),
                        value: key
                    };
                    switch (key) {
                    case "routes":
                        newItem.children = this.computeValueRoute(results[key]);
                        break;
                    case "files":
                        newItem.children = this.computeValueFile(results[key]);
                        break;
                    case "users":
                        newItem.children = this.computeValueUser(results[key]);
                        break;
                    default: break;
                    }
                    menuItems.push(newItem);
                }
            });
            return menuItems;
        },
        computeValueRoute(routeList) {
            var resultList = [];
            routeList.forEach((route) => {
                resultList.push({
                    label: route.meta.title,
                    value: route.name
                });
            });
            return resultList;
        },
        computeValueFile(fileList) {
            var resultList = [];
            fileList.forEach((file) => {
                resultList.push({
                    label: file.fullName,
                    value: file.fullName
                });
            });
            return resultList;
        },
        computeValueUser(userList) {
            var resultList = [];
            userList.forEach((user) => {
                resultList.push({
                    label: user.name,
                    value: user.email
                });
            });
            return resultList;
        },
        // TODO: More than one files being dropped at once should trigger one -and only one- request
        fileDragged(event) {
            this.fileUpload(event.dataTransfer.files);
        },
        block(event) {
            event.preventDefault();
            event.stopPropagation();
        }
    }
};

</script>
<style>
.topbar {
    -webkit-box-shadow: 0px 0px 15px 0px rgba(0,0,0,0.37);
    -moz-box-shadow: 0px 0px 15px 0px rgba(0,0,0,0.37);
    box-shadow: 0px 0px 15px 0px rgba(0,0,0,0.37);
}
</style>
